From: Mimi Zohar <zohar-23VcF4HTsmIX0ybBhKVfKdBPR1lH4CV8@public.gmane.org>
To: initramfs-u79uwXL29TY76Z2rM5mHXA@public.gmane.org
Cc: Mimi Zohar <zohar-23VcF4HTsmIX0ybBhKVfKdBPR1lH4CV8@public.gmane.org>
Subject: [PATCH 2/4] Extend evm-enable.sh to load the EVM public key
Date: Mon, 27 Apr 2015 18:24:12 -0400 [thread overview]
Message-ID: <1430173454-3665-2-git-send-email-zohar@linux.vnet.ibm.com> (raw)
In-Reply-To: <1430173454-3665-1-git-send-email-zohar-23VcF4HTsmIX0ybBhKVfKdBPR1lH4CV8@public.gmane.org>
Create the _evm keyring and load the EVM public key on it.
---
modules.d/98integrity/evm-enable.sh | 42 +++++++++++++++++++++++++++++++++++++
1 file changed, 42 insertions(+)
diff --git a/modules.d/98integrity/evm-enable.sh b/modules.d/98integrity/evm-enable.sh
index dee1c6c..ec4f03b 100755
--- a/modules.d/98integrity/evm-enable.sh
+++ b/modules.d/98integrity/evm-enable.sh
@@ -48,6 +48,45 @@ load_evm_key()
info "integrity: failed to load the EVM encrypted key: ${EVMKEYDESC}";
return 1;
}
+ return 0
+}
+
+load_evm_x509()
+{
+ info "Load EVM IMA X509"
+
+ # override the EVM key path name from the 'evmx509=' parameter in
+ # the kernel command line
+ EVMX509ARG=$(getarg evmx509=)
+ [ $? -eq 0 ] && \
+ EVMX509=${EVMX509ARG}
+
+ # set the default value
+ [ -z "${EVMX509}" ] && \
+ EVMX509="/etc/keys/x509_evm.der";
+
+ # set the EVM public key path name
+ EVMX509PATH="${NEWROOT}${EVMX509}"
+
+ # check for EVM public key's existence
+ if [ ! -f "${EVMX509PATH}" ]; then
+ if [ "${RD_DEBUG}" = "yes" ]; then
+ info "integrity: EVM x509 cert file not found: ${EVMX509PATH}"
+ fi
+ return 1
+ fi
+
+ # load the EVM public key onto the EVM keyring
+ evm_pubid=`keyctl newring _evm @u`
+ EVMX509ID=$(evmctl import ${EVMX509PATH} ${evm_pubid})
+ [ $? -eq 0 ] || {
+ info "integrity: failed to load the EVM X509 cert ${EVMX509PATH}";
+ return 1;
+ }
+
+ if [ "${RD_DEBUG}" = "yes" ]; then
+ keyctl show @u
+ fi
return 0
}
@@ -76,6 +115,9 @@ enable_evm()
# load the EVM encrypted key
load_evm_key || return 1
+ # load the EVM public key, if it exists
+ load_evm_x509
+
# initialize EVM
info "Enabling EVM"
echo 1 > ${EVMSECFILE}
--
2.1.0
next prev parent reply other threads:[~2015-04-27 22:24 UTC|newest]
Thread overview: 5+ messages / expand[flat|nested] mbox.gz Atom feed top
2015-04-27 22:24 [PATCH 1/4] Remove 98integrity's dependency on selinux Mimi Zohar
[not found] ` <1430173454-3665-1-git-send-email-zohar-23VcF4HTsmIX0ybBhKVfKdBPR1lH4CV8@public.gmane.org>
2015-04-27 22:24 ` Mimi Zohar [this message]
2015-04-27 22:24 ` [PATCH 3/4] Define new script to load keys on the IMA keyring Mimi Zohar
[not found] ` <1430173454-3665-3-git-send-email-zohar-23VcF4HTsmIX0ybBhKVfKdBPR1lH4CV8@public.gmane.org>
2015-04-29 15:05 ` [PATCH 3/4] Define new script to load keys on the IMA keyring (update) Mimi Zohar
2015-04-27 22:24 ` [PATCH 4/4] Revert securitfs change Mimi Zohar
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1430173454-3665-2-git-send-email-zohar@linux.vnet.ibm.com \
--to=zohar-23vcf4htsmix0ybbhkvfkdbpr1lh4cv8@public.gmane.org \
--cc=initramfs-u79uwXL29TY76Z2rM5mHXA@public.gmane.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox